-- NW4C_ForBanner Attribute Copy Tool (2011/01/28)
-- Version 0.5.4
-- (c)2010-2011 Nintendo

struct nw4cForBanner_AttrCopyTool
(
	nw4c = nw4cmax,
	nw4c4b = nw4cmax_banner,
	
	fn copyMatAttr m =
	(
		local attr = m.custAttributes["NW4C Material Custom Attribute"]
		if attr != undefined do
		(
			local attr4b = m.custAttributes["NW4C_ForBanner Material Custom Attribute"]
			if attr4b == undefined do
			(
				attr4b = nw4c_forbanner_mtl_custom_attribute()
				append m.custAttributes attr4b
			)
			attr4b.faceCulling = attr.faceCulling
			attr4b.compress = attr.compress
			attr4b.fragmentLighting = attr.fragmentLighting
			attr4b.vertexLighting = attr.vertexLighting
			attr4b.renderPriorityType = attr.renderPriorityType
			attr4b.renderPriority = attr.renderPriority
			attr4b.blendMode = attr.blendMode
			attr4b.userSettings = attr.userSettings
		)
		
		if(classOf m == Multimaterial) do
		(
			for submtl in m.materialList do
			(
				copyMatAttr submtl
			)
		)
	),
	
	fn copyNodeAttrRecurcive n =
	(
		local attr = n.custAttributes["NW4C Node Custom Attribute"]
		if attr != undefined do
		(
			local attr4b = n.custAttributes["NW4C_ForBanner Node Custom Attribute"]
			if attr4b == undefined do
			(
				attr4b = nw4c_forbanner_node_custom_attribute()
				append n.custAttributes attr4b
			)
			attr4b.noCompress = attr.noCompress
			attr4b.billboardType = attr.billboardType
			attr4b.combineGroup = attr.combineGroup
			attr4b.exportScaleKey = attr.exportScaleKey
			attr4b.exportRotateKey = attr.exportRotateKey
			attr4b.exportTranslateKey = attr.exportTranslateKey
			attr4b.userSettings = attr.userSettings
		)
		
		if n != rootnode and n.material != undefined do
		(
			copyMatAttr n.material
		)
		
		for c in n.children do 
		(
			copyNodeAttrRecurcive c
		)
	),
	
	fn doCopy =
	(
		copyNodeAttrRecurcive rootnode
	)
)

if nw4cmax == undefined or nw4cmax_banner == undefined then
(
	messageBox "nw4c Plugin and nw4c_forBanner plugin must be installed."
)
else
(
	local copytool = nw4cForBanner_AttrCopyTool()
	copytool.doCopy()
	
	local nw4c = nw4cmax
	local nw4c4b = nw4cmax_banner
	nw4c4b.doesExportSelected = nw4c.doesExportSelected
	nw4c4b.outFolder = nw4c.outFolder
	nw4c4b.filename = nw4c.filename
	nw4c4b.UseCreativeStudio = nw4c.UseCreativeStudio
	nw4c4b.doesExportAnimation = nw4c.doesExportAnimation
	nw4c4b.doesExportTexture = nw4c.doesExportTexture
	nw4c4b.doesExportModel = nw4c.doesExportModel
	nw4c4b.doesExportCamera = nw4c.doesExportCamera
	nw4c4b.doesExportLight = nw4c.doesExportLight
	nw4c4b.doesExportMtlAnim = nw4c.doesExportMtlAnim
	nw4c4b.doesExportEnv = nw4c.doesExportEnv
	nw4c4b.doesExportModelAnim = nw4c.doesExportModelAnim
	nw4c4b.doesExportAllFrames = nw4c.doesExportAllFrames
	nw4c4b.StartFrame = nw4c.StartFrame
	nw4c4b.EndFrame = nw4c.EndFrame
	nw4c4b.AnimPrecision = nw4c.AnimPrecision
	nw4c4b.IsLoop = nw4c.IsLoop
	nw4c4b.Magnify = nw4c.Magnify
	nw4c4b.CompressNode = nw4c.CompressNode
	nw4c4b.OptimizePrimitive = nw4c.OptimizePrimitive
	nw4c4b.OptimizeMaterial = nw4c.OptimizeMaterial
	nw4c4b.DisableModelSimplification = nw4c.DisableModelSimplification
	nw4c4b.NonUniformScale = nw4c.NonUniformScale
	nw4c4b.ReservedUniformRegister = nw4c.ReservedUniformRegister
	nw4c4b.VisibilityBindByName = nw4c.VisibilityBindByName
	nw4c4b.ToleranceTrans = nw4c.ToleranceTrans
	nw4c4b.ToleranceRotate = nw4c.ToleranceRotate
	nw4c4b.ToleranceScale = nw4c.ToleranceScale
	nw4c4b.ToleranceUVTrans = nw4c.ToleranceUVTrans
	nw4c4b.ToleranceUVRotate = nw4c.ToleranceUVRotate
	nw4c4b.ToleranceUVScale = nw4c.ToleranceUVScale
	nw4c4b.ToleranceColor = nw4c.ToleranceColor
	nw4c4b.PrecisionTrans = nw4c.PrecisionTrans
	nw4c4b.PrecisionRotate = nw4c.PrecisionRotate
	nw4c4b.PrecisionScale = nw4c.PrecisionScale
	nw4c4b.QuantPos = nw4c.QuantPos
	nw4c4b.QuantNormal = nw4c.QuantNormal
	nw4c4b.QuantTex = nw4c.QuantTex
	nw4c4b.ScaleQuality = nw4c.ScaleQuality
	nw4c4b.RotateQuality = nw4c.RotateQuality
	nw4c4b.TransQuality = nw4c.TransQuality
	nw4c4b.UseFigureMode = nw4c.UseFigureMode
	nw4c4b.IsFrameFormat = nw4c.IsFrameFormat
	nw4c4b.UseMerge = nw4c.UseMerge
	nw4c4b.MergeFilename = nw4c.MergeFilename
	nw4c4b.SkinningMode = nw4c.SkinningMode
	nw4c4b.SaveSetting()
)
