-- NW4C Batch Export Script (2013/11/14)
-- Version 0.5.1b
-- (c)2010-2011 Nintendo

-- Check for exietence of nw4c exporter.

if (nw4cmax_banner != undefined) do
(
	--Configure directory.
	local inDir, outDir, inFilesWC
	inDir = getSavePath caption:"nw4c for banner batch export\n Select the folder with the max file to convert."
	format "\nInput Folder: %s\n" inDir
	if (inDir != undefined) do
	(
		outDir = getSavePath caption:"nw4c for banner batch export\n Select the folder to write to." initialDir:inDir
		format "Output Folder: %s\n" outDir
		if (outDir != undefined) do 
		(
			inFilesWC = inDir + "\\*.max"
			local files = getFiles inFilesWC
			format "\nBegin Export\n"
			local errCount = 0
			local errFiles = ""
			
			for f in files do
			(
				format "-----------------------------\n"
				format "Export Max File(%)\n" f
				outFilename = outDir + "\\" + (getFilenameFile f) + ".cmdl"
				-- Load and export the max file.
				--resetMaxFile #noPrompt
				if (loadMaxFile f quiet:true useFileUnits:true) then
				(
					completeRedraw()
					local nw4c = nw4cmax_banner
					nw4c.LoadSetting()
					nw4c.outFolder = outDir
					nw4c.UseCreativeStudio = false
					nw4c.filename = (getFilenameFile f)
					try
					(
						local ret = nw4cmax_banner.doExport false
						if not ret do 
						(
							errCount = errCount + 1
							append errFiles (f + "\n")
							format "Export Error\n"
						)
					)
					catch
					(
						format "Unknown System Error\n"
						errCount = errCount + 1
						append errFiles (f + "\n")
					)
				)
				else
				(
					format "Load Error\n"
					append errFiles (f + "\n")
				)
				
			)
			format "Finish Export\n"
			resetMaxFile #noPrompt
			
			if (errCount > 0) then
			(
				local mes = ("Exporting error in " + errCount as String + "files\n\n")
				append mes errFiles
				messagebox mes
			)
			else
			(
				messagebox "Finish Export"
			)
		)
	)
)
