-- NW4C_ForBanner Material Tool (2013/11/14)
-- Version 0.5.1b
-- (c)2010-2011 Nintendo

rollout nw4c4bMaterialRollout "NW4C_ForBanner Set Material Attribute" width:480 height:550
(
	groupBox grp1 "Selected Material" pos:[8,8] width:464 height:170
	--label lblSelectedNode "" pos:[16,24] width:368 height:64
	dotNetControl lv_mtl "System.Windows.Forms.ListView" pos:[16,24] width:450 height:150
	--
	groupBox grp2 "Set" pos:[8,184] width:464 height:126
	dropDownList ddlSetFaceCulling "Face Culling" pos:[16,200] width:152 height:41 \
			items:#("Back Face", "Front Face", "Always", "Never")
	dropDownList ddlSetCompress "Compress" pos:[184,200] width:152 height:41 \
			items:#("Compress if possible", "Donft compress")
	checkbox chkSetFragmentLighting "Fragment Lighting" pos:[16,244] width:152 height:16
	checkbox chkSetVertexLighting "Vertex Lighting" pos:[184,244] width:152 height:16
	dropDownList ddlSetBlendMode "Blend Mode" pos:[16,264] width:152 height:41 \
			items:#("Auto", "Opaque", "Alpha Test", "Translucent", "Add", "Sub", "Multiply")
	--
	groupBox grp3 "Search" pos:[8,318] width:464 height:200
	label lbl2 "Face Culling" pos:[16,334] width:80 height:16
	checkbox chkSFC_Front "Front Face" pos:[144,334] width:80 height:16
	checkbox chkSFC_Back "Back Face" pos:[224,334] width:80 height:16
	checkbox chkSFC_Always "Always" pos:[304,334] width:64 height:16
	checkbox chkSFC_Never "Never" pos:[368,334] width:56 height:16
	label lbl3 "Fragment Lighting" pos:[16,358] width:120 height:16
	checkbox chkSFL_Off "off" pos:[144,358] width:48 height:16
	checkbox chkSFL_On "on" pos:[192,358] width:40 height:16
	label lbl4 "Vertex Lighting" pos:[16,382] width:120 height:16
	checkbox chkSVL_Off "off" pos:[144,382] width:48 height:16
	checkbox chkSVL_On "on" pos:[192,382] width:40 height:16
	label lbl5 "Compress" pos:[16,406] width:120 height:16
	checkbox chkSC_On "If possible" pos:[144,406] width:80 height:16
	checkbox chkSC_Off "Don't" pos:[224,406] width:104 height:16


	label lbl6 "Blend Mode" pos:[16,430] width:120 height:16
	checkbox chkBM_Auto "Auto" pos:[144,430] width:80 height:16
	checkbox chkBM_Opaque "Opaque" pos:[224,430] width:80 height:16
	checkbox chkBM_AlphaTest "Alpha Test" pos:[304,430] width:80 height:16
	checkbox chkBM_Translucent "Translucent" pos:[144,454] width:80 height:16
	checkbox chkBM_Add "Add" pos:[234,454] width:60 height:16
	checkbox chkBM_Sub "Sub" pos:[294,454] width:60 height:16
	checkbox chkBM_Multiply "Multiply" pos:[358,454] width:80 height:16
	
	--
	radioButtons rdoSearchType "" pos:[192,494] width:98 height:16 labels:#("AND", "OR") columns:2
	button btnSearch "Search" pos:[304,484] width:112 height:24
	button btnClose "Close" pos:[8,522] width:464 height:24

	local donotRedraw
	local mtls = #()
	local nodeCallbacks =#()
	fn initListView =
	(
		lv_mtl.gridLines = true
		lv_mtl.View = (dotNetClass "System.Windows.Forms.View").Details
		lv_mtl.fullRowSelect = true
		lv_mtl.AutoSize = true
		lv_mtl.MultiSelect = false
		lv_mtl.Columns.add "Material Name" 
		lv_mtl.Columns.add "Face Culling" 
		lv_mtl.Columns.add "Fragment" 
		lv_mtl.Columns.add "Vertex" 
		lv_mtl.Columns.add "Compress     "
		lv_mtl.Columns.add "BlendMode"
		lv_mtl.sorting = (dotNetClass "System.Windows.Forms.SortOrder").Ascending
		lv_mtl.AutoResizeColumns ((dotNetClass "System.Windows.Forms.ColumnHeaderAutoResizeStyle").HeaderSize)
	)

	/**/
	fn getMtlAttribute m create =
	(
		local attrib = m.custAttributes["NW4C_ForBanner Material Custom Attribute"]
		if attrib == undefined then
		(
			--if not create do return undefined 
			print nw4c_forbanner_mtl_custom_attribute
			local tmp = nw4c_forbanner_mtl_custom_attribute()
			attrib = tmp
			append m.custAttributes attrib
		)
		return attrib
	)
	/**/

	fn getSelMtls sel = 
	(
		local smtls = #()
		for n in sel do
		(
			local mtl = n.material
			if mtl != undefined do
			(
				appendIfUnique smtls mtl
				if(classOf mtl == Multimaterial) do
				(
					for submtl in mtl.materialList do
					(
						appendIfUnique smtls submtl
					)
				)
			)
		)
		return smtls
	)
	
	fn enableUI flag =
	(
		ddlSetFaceCulling.enabled = flag
		ddlSetCompress.enabled = flag
		chkSetFragmentLighting.enabled = flag
		chkSetVertexLighting.enabled = flag
		ddlSetBlendMode.enabled = flag
	)
	
	fn loadAttributeToUI attr =
	(
		if (classof attr) != nw4c_forbanner_mtl_custom_attribute do return()
		
		ddlSetFaceCulling.selection = attr.faceCulling + 1
		ddlSetCompress.selection = attr.compress + 1
		chkSetFragmentLighting.checked = attr.fragmentLighting
		chkSetVertexLighting.checked = attr.vertexLighting
		ddlSetBlendMode.selection = attr.blendMode + 1
	)

	fn updateSelection =
	(
		if donotRedraw do return()
		lv_mtl.Items.Clear()
		--print "updateSelection"
		--print mtls

		local str = ""
		--local mtls = getSelMtls selection
		
		local lvItems =#()
		for m in mtls do
		(
			local attr = getMtlAttribute m true

			local li = dotNetObject "System.Windows.Forms.ListViewItem" m.name
			local sub_li 
			str = case attr.faceCulling of
				(
					0: "Back Face"
					1: "Front Face"
					2: "Always"
					default: "Never"
				)
			sub_li = li.SubItems.add str
			
			sub_li = li.SubItems.add (if attr.fragmentLighting then "on" else "off")
			sub_li = li.SubItems.add (if attr.vertexLighting then "on" else "off")

			str = case attr.compress of
				(
					0: "If possible"
					default: "Donft"
				)
			sub_li = li.SubItems.add str

			str = case attr.blendMode of
				(
					0: "Auto"
					1: "Opaque"
					2: "Alpha Test"
					3: "Translucent"
					4: "Add"
					5: "Sub"
					default: "Multiply"
				)
			sub_li = li.SubItems.add str

			append lvItems li
		)
		--print lvItems
		lv_mtl.Items.AddRange lvItems 
		
		--lblSelectedNode.text = str
		if mtls.count > 0 then
		(
			enableUI  true
			loadAttributeToUI (getMtlAttribute mtls[1] false)
		)
		else
		(
			enableUI false
		)
	)
	
	fn mtlUpdateCallback ev nd = 
	(
		format "mtlUpdateCallback %(%), %\n" (classof ev) (ev as string) (nd as string)
		updateSelection()
	)
	
	fn updateNodeCallbacks = 
	(
		local nodes =#()
		nodeCallbacks =#()
		gc()
		for m in mtls do
		(
			local n = refs.dependentNodes m
			if n != undefined do 
			(
				if (appendIfUnique nodes n) do
				(
					local cb = NodeEventCallback mouseUp:true delay:1000 materialOtherEvent:mtlUpdateCallback
					append nodeCallbacks cb
				)
			)
		)
	)

	fn setMtlAttributes =
	(
		--local mtls = getSelMtls selection
		local attr
		for m in mtls do
		(
			attr = getMtlAttribute m true
			attr.faceCulling = ddlSetFaceCulling.selection - 1
			attr.compress = ddlSetCompress.selection - 1
			attr.fragmentLighting = chkSetFragmentLighting.checked
			attr.vertexLighting = chkSetVertexLighting.checked
			attr.blendMode = ddlSetBlendMode.selection - 1
		)
		updateSelection()
	)
	
	fn selectionCallback = 
	(
		mtls = getSelMtls selection
		--updateNodeCallbacks()
		updateSelection()
	)
	
	fn addCallback = 
	(
		callbacks.addScript #selectionSetChanged "nw4c4bMaterialRollout.selectionCallback()" id:#nw4c4bMtlSelectionChange
	)
	fn removeCallback = 
	(
		callbacks.removeScripts id:#nw4c4bMtlSelectionChange
	)
	
	-- If all bools within the array are false, then true.
	fn isAllBoolFalse bools = 
	(
		if classof bools != Array do return false
		local allOn = true, allOff = false
		for b in bools	do
		(
			allOn = allOn and b
			allOff = allOff or b
		)
		local ret = if allOn or not allOff then true else false
		--format "isAllBoolSame % \n"	ret
		--return ret
		return (not allOff)
	)
	on lv_mtl SelectedIndexChanged e do
	(
		local numItems = lv_mtl.Items.Count
		for i = 0 to (numItems - 1) do
		(
			lv_mtl.Items.Item[i].Selected = false
		)
	)
	on btnSearch pressed  do 
	(
		removeCallback()
		local allMtls = getSelMtls objects
		mtls = #()
		local searchFaceCull, searchFragLight, searchVtxLight, searchCompress, searchBlend
		-- face
		local fc_front = chkSFC_Front.checked
		local fc_back = chkSFC_Back.checked
		local fc_always = chkSFC_Always.checked
		local fc_never = chkSFC_Never.checked
		searchFaceCull = not (isAllBoolFalse #(fc_front, fc_back,fc_always,fc_never) )
		
		local fl_on = chkSFL_On.checked
		local fl_off = chkSFL_Off.checked
		searchFragLight = not (isAllBoolFalse #(fl_on, fl_off) )

		local vl_on = chkSVL_On.checked
		local vl_off = chkSVL_Off.checked
		searchVtxLight = not (isAllBoolFalse #(vl_on, vl_off) )

		local comp_on = chkSC_On.checked
		local comp_off = chkSC_Off.checked
		searchCompress = not (isAllBoolFalse #(comp_on, comp_off) )
		
		local bmAuto = chkBM_Auto.checked
		local bmOpaque = chkBM_Opaque.checked
		local bmAlphaTest = chkBM_AlphaTest.checked
		local bmTranslucent = chkBM_Translucent.checked
		local bmAdd = chkBM_Add.checked
		local bmSub = chkBM_Sub.checked
		local bmMultiply = chkBM_Multiply.checked
		searchBlend = not (isAllBoolFalse #(bmAuto, bmOpaque, bmAlphaTest, bmTranslucent, bmAdd, bmSub, bmMultiply) )
			
		local isSearchAnd = if rdoSearchType.state == 1 then true else false	
		
		for m in allMtls do
		(
			local compare = true -- Determines if to continue comparisons under other conditions?
			local ret =false -- Determines if this material satisfied the comparison conditions.
			local attr = getMtlAttribute m true
			if searchFaceCull and compare do
			(
				ret = case attr.faceCulling of
				(
					0: fc_back
					1: fc_front
					2: fc_always
					3: fc_never
				)
				if ret and (not isSearchAnd) then compare = false -- If this comparison condition is satisfied and the mode is OR, other comparisons are unnecessary.
				else if (not ret) and isSearchAnd do compare = false -- If this comparison condition is not satisfied and the mode is AND, other comparisons are unnecessary.
			)

			if searchFragLight and compare do
			(
				ret = (attr.fragmentLighting == fl_on) or (attr.fragmentLighting == (not fl_off))
				if ret and (not isSearchAnd) then compare = false
				else if (not ret) and isSearchAnd do compare = false
			)

			if searchVtxLight and compare do
			(
				ret = (attr.vertexLighting == vl_on) or (attr.vertexLighting == (not vl_off))
				if ret and (not isSearchAnd) then compare = false
				else if (not ret) and isSearchAnd do compare = false
			)

			if searchCompress and compare do
			(
				local isComp = (attr.compress == 0)
				ret = (isComp == comp_on) or (isComp == (not comp_off))
				if ret and (not isSearchAnd) then compare = false
				else if (not ret) and isSearchAnd do compare = false
			)
			
			if searchBlend and compare do
			(
				ret = case attr.blendMode of
				(
					0: bmAuto
					1: bmOpaque
					2: bmAlphaTest
					3: bmTranslucent
					4: bmAdd
					5: bmSub
					6: bmMultiply
					default: bmAuto
				)
				if ret and (not isSearchAnd) then compare = false
				else if (not ret) and isSearchAnd do compare = false
			)
			
			-- Adds materials to the array if the conditions are met.
			if ret do
			(
				append mtls m
			)
		)
		--print mtls
		clearSelection()
		for m in mtls do
		(
			selectMore (refs.dependentNodes m)
		)
		--updateNodeCallbacks()
		updateSelection()
		addCallback()
	)
	
	
/*
   	on lv_mtl ColumnClick evt do
	(
		if (lv_mtl.ListViewItemSorter.Column != evt.Column) then
		(
			lv_mtl.ListViewItemSorter.Column = evt.Column
			lv_mtl.ListViewItemSorter.Reversed = false
		)
		else
		(
			lv_mtl.ListViewItemSorter.Reversed = (not lv_mtl.ListViewItemSorter.Reversed)
		)
		lv_mtl.Sort()
	)	 
*/	
	on ddlSetFaceCulling selected i do setMtlAttributes()
	on ddlSetCompress selected i do setMtlAttributes()
	on chkSetFragmentLighting changed i do setMtlAttributes()
	on chkSetVertexLighting changed i do setMtlAttributes()
	on ddlSetBlendMode selected i do setMtlAttributes()

	on nw4c4bMaterialRollout open  do
	(
		donotRedraw = false
		initListView()
		addCallback()
		--updateSelection()
		selectionCallback()
	)
	on nw4c4bMaterialRollout close  do
	(
		removeCallback()
	)
	on btnClose pressed  do DestroyDialog nw4c4bMaterialRollout
)-- mtl rollout

rollout nw4c4bRenderPriorityRollout "NW4C_ForBanner Set Render Priority" width:480 height:400
(
	groupBox grp1 "Selected Material" pos:[8,8] width:464 height:170
	dotNetControl lv_mtl "System.Windows.Forms.ListView" pos:[16,24] width:450 height:150

	groupBox grp2 "Set" pos:[8,187] width:464 height:61
	label lbl6 "Render Priority:" pos:[24,208] width:104 height:16
	radioButtons rdoSetPriorityType "" pos:[128,208] width:87 height:32 labels:#("Don't care", "") columns:1 default:1
	spinner spnSetPriority "" pos:[152,224] width:56 height:16 range:[1,255,1] type:#integer scale:1 enabled:false
	label lbl7 "1(High Priority) - 255(Low Priority)" pos:[224,224] width:240 height:16

	groupBox grp4 "Search" pos:[8,256] width:464 height:104
	label lbl8 "Render Priority:" pos:[24,280] width:104 height:16
	radioButtons rdoSearchPriorityType "" pos:[128,280] width:89 height:48 
			labels:#("Don't care", "Condition", "All Material") columns:1 default:1 \
	dropDownList ddlSearchConditionType "" pos:[208,292] width:96 height:22 default:1 enabled:false \
			items:#("< : under", "<= : below", "= : exactly", ">= : above", "> : over") 
	spinner spnSearchPriority "" pos:[312,294] width:48 height:16 range:[1,255,1] type:#integer scale:1 enabled:false

	button btnSearch "Search" pos:[280,328] width:112 height:24
	button btnClose "Close" pos:[8,368] width:464 height:24
	
	local mtls =#()

	fn getMtlAttribute m create =
	(
		local attrib = m.custAttributes["NW4C_ForBanner Material Custom Attribute"]
		if attrib == undefined then
		(
			--if not create do return undefined 
			attrib = nw4c_forbanner_mtl_custom_attribute()
			append m.custAttributes attrib
		)
		return attrib
	)

	fn initListView =
	(
		lv_mtl.gridLines = true
		lv_mtl.View = (dotNetClass "System.Windows.Forms.View").Details
		lv_mtl.fullRowSelect = true
		lv_mtl.AutoSize = true
		lv_mtl.MultiSelect = false
		lv_mtl.LabelEdit = true
		lv_mtl.AllowColumnReorder = true
		lv_mtl.Columns.add "Render Priority" 
		lv_mtl.Columns.add "Material Name" 
		lv_mtl.Columns.Item[0].DisplayIndex = 1
		lv_mtl.Columns.Item[1].DisplayIndex = 0
		--lv_mtl.sorting = (dotNetClass "System.Windows.Forms.SortOrder").Ascending
		lv_mtl.AutoResizeColumns ((dotNetClass "System.Windows.Forms.ColumnHeaderAutoResizeStyle").HeaderSize)
		
	)
	
	fn getSelMtls sel = 
	(
		local smtls = #()
		for n in sel do
		(
			local mtl = n.material
			if mtl != undefined do
			(
				appendIfUnique smtls mtl
				if(classOf mtl == Multimaterial) do
				(
					for submtl in mtl.materialList do
					(
						appendIfUnique smtls submtl
					)
				)
			)
		)
		return smtls
	)

	fn updateSelection =
	(
		lv_mtl.Items.Clear()

		local str = ""
		--local mtls = getSelMtls selection
		
		local lvItems =#()
		for m in mtls do
		(
			local attr = getMtlAttribute m true
			local val = 0
			if attr.renderPriorityType == 1 do
			(
				val = attr.renderPriority
			)
			local li = dotNetObject "System.Windows.Forms.ListViewItem" (val as string)
			local sub_li = li.SubItems.add m.name
			append lvItems li
		)
		lv_mtl.Items.AddRange lvItems 
	)
	
	fn setMtlAttributes =
	(
		--local mtls = getSelMtls selection
		local attr
		undo "Edit render priority" on
		(
			spnSetPriority.enabled = (rdoSetPriorityType.state == 2)
			for m in mtls do
			(
				attr = getMtlAttribute m true
				local val = 0
				if rdoSetPriorityType.state == 1 then
				(
					attr.renderPriorityType = 0
				)
				else
				(
					attr.renderPriorityType = 1
					attr.renderPriority = spnSetPriority.value
				)
			)
		)
		updateSelection()
	)
	
	fn selectionCallback = 
	(
		mtls = getSelMtls selection
		updateSelection()
	)
	
	fn addCallback = 
	(
		callbacks.addScript #selectionSetChanged "nw4c4bRenderPriorityRollout.selectionCallback()" \
				id:#nw4c4bRenderPrioritySelectionChange
	)
	fn removeCallback = 
	(
		callbacks.removeScripts id:#nw4c4bRenderPrioritySelectionChange
	)
	
	on btnSearch pressed  do 
	(
		removeCallback()
		local allMtls = getSelMtls objects
		mtls = #()
	
		for m in allMtls do
		(
			local attr = getMtlAttribute m true
			local ret= false
			
			case rdoSearchPriorityType.state of
			(
				1: ( -- Do not care
					if attr.renderPriorityType == 0 do
					(
						ret = true
					)
				)
				2: ( -- condition
					if attr.renderPriorityType == 1 do
					(
						local v = spnSearchPriority.value
						case ddlSearchConditionType.selection of
						(
							1: ( -- under
								ret = (attr.renderPriority < v)
							)
							2: ( -- below
								ret = (attr.renderPriority <= v)
							)
							3: ( -- exactly
								ret = (attr.renderPriority == v)
							)
							4: ( -- above
								ret = (attr.renderPriority >= v)
							)
							5: ( -- Over
								ret = (attr.renderPriority > v)
							)
						)
					)
				)
				default: ret = true
			)
			
			-- Adds materials to the array if the conditions are met.
			if ret do
			(
				append mtls m
			)
		)

		clearSelection()
		for m in mtls do
		(
			selectMore (refs.dependentNodes m)
		)

		updateSelection()
		addCallback()
	)
	
	on lv_mtl AfterLabelEdit ev do
	(
		local str = ev.Label
		local cancel = true
		if str != undefined do 
		(
			local v = str as Integer
			if v != undefined  do
			(
				if (1 <= v) and (v <= 255) do
				(
					local subItem = lv_mtl.Items.item[ev.Item].subitems
					local eMtl = subItem.Item[1].Text
					--format "set priority \"%\" = %\n" eMtl v
					local attr = undefined
					for m in sceneMaterials while attr == undefined do
					(
						if m.name == eMtl then
						(
							attr = getMtlAttribute m true
						)
						else if(classOf m == Multimaterial) do
						(
							for submtl in m.materialList while attr == undefined do
							(
								if submtl.name == eMtl then
								(
									attr = getMtlAttribute submtl true
								)
							)
						)
					)
					
					if attr != undefined do
					(
						attr.renderPriorityType = if (v == 0) then 0 else 1
						attr.renderPriority = v
						cancel = false
					)
				)
			)
		)
		ev.CancelEdit = cancel
	)
	
	on rdoSetPriorityType changed i do setMtlAttributes()
	on spnSetPriority changed i do setMtlAttributes()
	
	on rdoSearchPriorityType changed i do 
	(
		ddlSearchConditionType.enabled = (i == 2)
		spnSearchPriority.enabled = (i == 2)
	)


	on nw4c4bRenderPriorityRollout lbuttondown mp do
	(
		--print mp
	)


	on nw4c4bRenderPriorityRollout open  do
	(
		mtls = #()
		--donotRedraw = false
		initListView()
		addCallback()
		--updateSelection()
		selectionCallback()
	)
	on nw4c4bRenderPriorityRollout close  do
	(
		removeCallback()
	)
	on btnClose pressed  do DestroyDialog nw4c4bRenderPriorityRollout
)-- priority rollout

rollout nw4c4bMtlUserDataRollout "NW4C_ForBanner Set Material User Data" width:480 height:290
(
	group "Selected Material"
	(
		label lblMtl
	)
	group "Edit Data"
	(
		button btnUp "Move Up" across:5
		button btnDown "Move Down" 
		button btnAdd "Add..."
		button btnDelete "Delete"
		button btnEdit "Edit..."
		dotNetControl lv_data "System.Windows.Forms.ListView" width:450 height:164
	)
	button btnClose "Close" width:474 height:24
		
	local utils = nw4c4b_utils()
	local dataset = undefined
	local mtl = undefined
	
	fn getMtlAttribute m create =
	(
		local attrib = m.custAttributes["NW4C_ForBanner Material Custom Attribute"]
		if attrib == undefined then
		(
			if not create do return undefined
			attrib = nw4c_forbanner_mtl_custom_attribute()
			append m.custAttributes attrib
		)
		return attrib
	)
	
	fn initListView =
	(
		lv_data.gridLines = true
		lv_data.View = (dotNetClass "System.Windows.Forms.View").Details
		lv_data.fullRowSelect = true
		lv_data.AutoSize = true
		lv_data.MultiSelect = false
		lv_data.Columns.add " Name   "
		lv_data.Columns.add " Type   "
		lv_data.Columns.add " Size"
		lv_data.Columns.add " Value"
		lv_data.AutoResizeColumns ((dotNetClass "System.Windows.Forms.ColumnHeaderAutoResizeStyle").HeaderSize)
	)
	
	fn saveData =
	(
		-- Processes when only 1 was selected.
		if superClassOf mtl != material do return false
			
		local attr = getMtlAttribute mtl true
		if attr != undefined do
		(
			attr.userSettings = dataset.toString()
		)
	)
	
	fn updateSelection =
	(
		lv_data.Items.Clear()
		dataset = nw4c4b_userDataSet()
		
		local lvItems =#()
		
		-- Processes when only 1 was selected.
		if superClassOf mtl == material then
		(
			lblMtl.text = mtl.name
			btnUp.enabled = true
			btnDown.enabled  = true
			btnAdd.enabled  = true
			btnDelete.enabled  = true
			btnEdit.enabled  = true
		)
		else
		(
			lblNode.text = ""
			btnUp.enabled = false
			btnDown.enabled  = false
			btnAdd.enabled  = false
			btnDelete.enabled  = false
			btnEdit.enabled  = false
			return ()
		)
		
		local attr = getMtlAttribute mtl false
		if attr != undefined then --If there are attributes
		(
			local str = attr.userSettings
			if (classof str) == String do
			(
				local ret = dataset.fromString str
				if ret do
				(
					for i = 1 to dataset.list.count do
					(
						local data = dataset.list[i]
						local li = dotNetObject "System.Windows.Forms.ListViewItem" data.dataname
						local sub_li 
						sub_li = li.SubItems.add (data.type as String)
						sub_li = li.SubItems.add ((data.valueCount()) as string)
						sub_li = li.SubItems.add ((data.valueToString oneline:true) as string)
						append lvItems li
					)
				)
			)
		)
		lv_data.Items.AddRange lvItems 
	)

	fn EditData data add = 
	(
		nw4c4bEditUserDataRollout_ValueSet = dataset
		nw4c4bEditUserDataRollout_Value = data
		CreateDialog  nw4c4bEditUserDataRollout modal:true
		if nw4c4bEditUserDataRollout_Value != undefined do
		(
			if add do dataset.appendData nw4c4bEditUserDataRollout_Value
			saveData()
			updateSelection()
		)
	)
	
	on nw4c4bMtlUserDataRollout open  do
	(
		initListView()
		mtl = medit.GetCurMtl()
		updateSelection()
	)
	on nw4c4bMtlUserDataRollout close  do
	(
	)
	
	on btnUp pressed do 
	(
		if lv_data.SelectedIndices.Count > 0 do
		(
			local id = lv_data.SelectedIndices.Item[0]
			local maxid = id + 1
			if id > 0 do
			(
				local tmp = dataset.list[maxid]
				deleteItem dataset.list (maxid)
				insertItem tmp dataset.list (maxid - 1)
				saveData()
				updateSelection()
				lv_data.Items.Item[id-1].Selected = true
			)
			lv_data.Focus()
		)
	)
	on btnDown pressed do 
	(
		if lv_data.SelectedIndices.Count > 0 do
		(
			local id = lv_data.SelectedIndices.Item[0]
			local maxid = id + 1
			if maxid < dataset.list.count do
			(
				local tmp = dataset.list[maxid]
				deleteItem dataset.list (maxid)
				insertItem tmp dataset.list (maxid + 1)
				saveData()
				updateSelection()
				lv_data.Items.Item[id+1].Selected = true
			)
			lv_data.Focus()
		)
	)

	on btnDelete pressed do 
	(
		if lv_data.SelectedIndices.Count > 0 do
		(
			local id = lv_data.SelectedIndices.Item[0]
			local maxid = id + 1
			(
				deleteItem dataset.list (maxid)
				saveData()
				updateSelection()
			)
			lv_data.Focus()
		)
	)

	on btnAdd pressed do 
	(
		if (classof dataset) == nw4c4b_userDataSet do
		(
			editData (nw4c4b_userData()) true
		)
	)
	
	on btnEdit pressed do 
	(
		if (classof dataset) == nw4c4b_userDataSet do
		(
			if lv_data.SelectedIndices.Count > 0 do
			(
				local id = lv_data.SelectedIndices.Item[0]
				local maxid = id + 1
				editData (dataset.list[maxid]) false
			)
		)
	)
	
	on btnClose pressed  do DestroyDialog nw4c4bMtlUserDataRollout
		
)-- Set Mtl User Data


-- Material editor menu
macroScript Nw4c4bAddMaterialAttribute category:"NW4C_ForBanner"
(
	local mtl = medit.GetCurMtl()
	if (mtl != undefined) and (superClassOf mtl == material) do
	(
		local attrib = mtl.custAttributes["NW4C_ForBanner Material Custom Attribute"]
		if attrib == undefined then
		(
			--if not create do return undefined 
			print nw4c_forbanner_mtl_custom_attribute
			local tmp = nw4c_forbanner_mtl_custom_attribute()
			attrib = tmp
			append mtl.custAttributes attrib
		)
-- 		nw4c4bMaterialRollout.getMtlAttribute mtl true
	)
)

macroScript Nw4c4bDeleteMaterialAttribute category:"NW4C_ForBanner"
(
	local mtl = medit.GetCurMtl()
	if (mtl != undefined) and (superClassOf mtl == material) do
	(
		deleteItem mtl.custAttributes "NW4C_ForBanner Material Custom Attribute"
	)
)

macroScript Nw4c4bSetMaterialUserData category:"NW4C_ForBanner"
(
	local mtl = medit.GetCurMtl()
	if (mtl != undefined) and (superClassOf mtl == material) do
	(
		CreateDialog  nw4c4bMtlUserDataRollout modal:true
	)
)

fn Nw4c4bGetMtlMenu =
(
	local mtlMenuBar = nw4cmax_banner.GetMtlEditorMenu()
	local flagFind = false
	local i = 1

	while (i <= mtlMenuBar.numitems() and (not flagFind)) do
	(
		local mi = mtlMenuBar.getItem i
		if ( (mi.getTitle()) == "NW4C_ForBanner" ) do
		(
			--format "remove menu(%) %\n" i mi
			mtlMenuBar.removeItemByPosition i
		)
		i += 1
	)

	-- Unregistered NW4F_ForBanner menu.
	local subMenu = menuMan.createMenu "NW4C_ForBanner"
	local subMenuItem = menuMan.createSubMenuItem "Test Menu" subMenu
	-- Adds the sub-menu to the slot that is second from the end.
	mtlMenuBar.addItem subMenuItem -1
	return subMenuItem
)

fn Nw4c4bResetMtlMenuActions mi =
(
	local menu = mi.getSubMenu()
	-- First, deletes already registered sub-menu items.
	while (menu.numItems() > 0) do
	(
		menu.removeItemByPosition 1
	)
	
	local dialogItem 

	dialogItem = menuMan.createActionItem "Nw4c4bAddMaterialAttribute" "NW4C_ForBanner"
	dialogItem.setTitle "Add Material Attribute"
	dialogItem.setUseCustomTitle true
	menu.addItem dialogItem -1

	dialogItem = menuMan.createActionItem "Nw4c4bDeleteMaterialAttribute" "NW4C_ForBanner"
	dialogItem.setTitle "Delete Material Attribute"
	dialogItem.setUseCustomTitle true
	menu.addItem dialogItem -1
	
	dialogItem = menuMan.createSeparatorItem()
	menu.addItem dialogItem -1
	
	dialogItem = menuMan.createActionItem "Nw4c4bSetMaterialUserData" "NW4C_ForBanner"
	dialogItem.setTitle "Set Material User Data"
	dialogItem.setUseCustomTitle true
	menu.addItem dialogItem -1
)
